##  HV.eventcount.pl
##
##  This Perl program writes the monthly and yearly counts for a set of sorted TABARI
##  events.
##   
##  TO RUN PROGRAM:
##
##  HV.eventcount.pl filename
##
##  where filename is the name of the file containing the event data. Output will 
##  be in the file filename.counts.
##
##  SYSTEM REQUIREMENTS
##  This program has been successfully run under Red Hat Linux 3.4.6-3; it is standard perl
##  so it should also run in Windows. 
##
##  PROVENANCE:
##  Programmer: Philip A. Schrodt
##              Kansas Event Data System Project
##              Center for International Political Analysis
##              University of Kansas 
##	            Lawrence, Kansas, 66045 U.S.A.
##	            http://web.ku.edu/keds
##
##	Copyright (c) 2009  Philip A. Schrodt.  All rights reserved.
##
## 	Redistribution and use in source and binary forms, with or without modification,
## 	are permitted under the terms of the GNU General Public License:
## 	http://www.opensource.org/licenses/gpl-license.html
##
##	Report bugs to: schrodt@ku.edu
##
##	For plausible indenting of this source code, set the tab size in your editor to "2"
##
##  REVISION HISTORY:
##  24-Jun-09:  Initial version
##
##  ----------------------------------------------------------------------------------

#!/usr/local/bin/perl

$mo = "";
$yr = "";
$kg = 0;
open(FIN,$ARGV[0])  or die "Can\'t open $ARGV[0] input file; error $!";
open(FOUT,">$ARGV[0].counts")  or die "Can\'t open output file; error $!";
while ($line = <FIN>) {
	$line =~ m/^(\d\d)(\d\d)/;
	if ($2 ne $mo) {
		if (length($yr) > 0) { print FOUT "$yr$mo  $km\n";}
		$km= 1;
		$mo = $2;
	}
	else { ++$km;}
	if ($1 ne $yr) {
		if (length($yr) > 0) { 
			print FOUT "             $year: $ky\n";
			$kg += $ky;
		}
		$ky= 1;
		$yr = $1;
		if ($yr =~ /^9/) { $year = "19$yr";}
		else { $year = "20$yr";}
		print FOUT "\nYEAR $year\n";
		print  "YEAR $year\n";
	}
	else { ++$ky;}	
}
print FOUT "$yr$mo  $km\n";
print FOUT "             $year: $ky\n";
print FOUT "\nGRAND TOTAL: $kg\n";

close(FIN) or die "Can\'t close output file ; error $!";
close(FOUT) or die "Can\'t close output file ; error $!";
print "Program has finished!\n";
