##  LN.data.counts.pl
##
##  This Perl program takes a sorted TABARI-formatted input file with LN record headers, and 
##  counts the number of records per day. File names are hard-coded.
##   
##  TO RUN PROGRAM:
##
##  perl LN.data.counts.pl filename
##
##  where filename is the file to be processed
##
##  SYSTEM REQUIREMENTS
##  This program has been successfully run under Mac OS 10.5; it is standard perl
##  so it should also run in Unix or Windows. 
##
##  PROVENANCE:
##  Programmer: Philip A. Schrodt
##              Kansas Event Data System Project
##              Center for International Political Analysis
##              University of Kansas 
##	            Lawrence, Kansas, 66045 U.S.A.
##	            http://web.ku.edu/keds
##
##	Copyright (c) 2009  Philip A. Schrodt.  All rights reserved.
##
## 	Redistribution and use in source and binary forms, with or without modification,
## 	are permitted under the terms of the GNU General Public License:
## 	http://www.opensource.org/licenses/gpl-license.html
##
##	Report bugs to: schrodt@ku.edu
##
##	For plausible indenting of this source code, set the tab size in your editor to "2"
##
##  REVISION HISTORY:
##  16-Jun-09:  Initial version
##
##  ----------------------------------------------------------------------------------

#!/usr/local/bin/perl

# ======== main program =========== #

open(FIN,"$ARGV[0]")  or die "Can\'t open input file; error $!";
open(FOUT,">counts.$ARGV[0]") or die "Can\'t open output file ; error $!";

$cur ="";
$ka = 0;
$ktot = 0;
while ($line = <FIN>) {
	if ($line =~ m/^(\d\d\d\d\d\d) \d\d\d/) {   # get line with a the date and record number
		if ($1 eq $cur) { ++$ka;}
		else {
			print "$cur: $ka\n";
			print FOUT "$cur: $ka\n";
			$cur = $1;
			$ktot += $ka;
			$ka=1;
		}
	}
}
print "Total stories: $ktot\n";
print FOUT "Total stories: $ktot\n";
close(FOUT) or die "Can\'t close output file ; error $!";
close(FIN) or die "Can\'t close input file ; error $!";
