##  LN.data.dups.pl
##
##  This Perl program takes a TABARI-formatted input file with LN record headers merge.6.1 
##  and removes duplicates within a single day based on the first 48 characters in the sentence. 
##  Unique entries are written to the file LN.unique.txt; the file dups.list1 contains a day-by-day
##  listing of the unique and dup record counts.
##   
##  TO RUN PROGRAM:
##
##  perl LN.data.dups.pl
##
##  SYSTEM REQUIREMENTS
##  This program has been successfully run under Mac OS 10.5; it is standard perl
##  so it should also run in Unix or Windows. 
##
##  PROVENANCE:
##  Programmer: Philip A. Schrodt
##              Kansas Event Data System Project
##              Center for International Political Analysis
##              University of Kansas 
##	            Lawrence, Kansas, 66045 U.S.A.
##	            http://web.ku.edu/keds
##
##	Copyright (c) 2009  Philip A. Schrodt.  All rights reserved.
##
## 	Redistribution and use in source and binary forms, with or without modification,
## 	are permitted under the terms of the GNU General Public License:
## 	http://www.opensource.org/licenses/gpl-license.html
##
##	Report bugs to: schrodt@ku.edu
##
##	For plausible indenting of this source code, set the tab size in your editor to "2"
##
##  REVISION HISTORY:
##  16-June-09:  Initial version
##
##  ----------------------------------------------------------------------------------

#!/usr/local/bin/perl

# ======== main program =========== #

print $file_name;
open(FIN,"merge.6.1")  or die "Can\'t open input file; error $!";
open(FOUT,">LN.unique.txt") or die "Can\'t open output file ; error $!";
open(FOUT2,">dups.list1") or die "Can\'t open output file ; error $!";
@notsort = ();
@sorted  = ();   # probably unnecessary...

$cur = "";
$ka = 0;
while ($line = <FIN>) {
	if ($line =~ m/^(\d\d\d\d\d\d) \d\d\d/) {   # get the date and record number
			$new = $line;
			while ($line = <FIN>) {
				if (length($line) == 1) {last;}
				$new = $new.$line;
			}
		if ($1 eq $cur) {
			push @notsort, $new;
		}
		else {
			@sorted = sort {substr($a,21,48) cmp substr($b,21,48)	} @notsort;
			
			$oldseg = "";
			$uniq = 0;
			$dup = 0;
			foreach $line (@sorted) {
				$newseg = substr($line,21,48);
				if ($newseg ne $oldseg) {
					++$uniq;
					$oldseg = $newseg;
#					$oldline = $line;
					print FOUT $line,"\n";
				}
				else {
					++$dup;
				}
			}
			print "$cur -- Unique: $uniq  Dups: $dup\n";
			print FOUT2"$cur -- Unique: $uniq  Dups: $dup\n";
			@notsort = ();
			push @notsort, $new;
			@sorted  = ();   # probably unnecessary...
			$cur = $1; # probably should be closer to the match
		}
	}
}
close(FOUT) or die "Can\'t close output file ; error $!";
close(FIN) or die "Can\'t close input file ; error $!";
print "Program has finished!\n";
